
var handler = require('../libs/event_handler').getHandler();
var memoryDb = require('../libs/memoryDb')

module.exports = function (app, passport, auth) {
  
  app.get('*', function(req, res, next){
      console.log('checking cloud init status');
      memoryDb.checkCloudInit(function(cloudInfo){
        console.log('cloud initiated'); 
        req.cloudinit = cloudInfo;
        console.log(req.cloudinit);
        next();
      });
  });

  app.get('/about',function(req,res){
    console.log('rendering about');
    res.render('about/show');
  });


	// admin routes
  var users = require('../app/controllers/users')
  app.get('/login', users.login)
  app.get('/signup', users.signup)
  app.get('/logout', users.logout)
  app.get('/user', users.show)
  app.put('/user', users.update);
  app.get('/auth/cloudcordinator', passport.authorize('cloudcordinator-auth', {scope: '*',  failureRedirect: '/login'}), users.show);
  app.get('/auth/cloudcordinator/callback', passport.authorize('cloudcordinator-auth', {scope: '*', failureRedirect: '/login'}), users.cloudCordinatorCallback);
  app.get('/', function(req, res){
        console.log(req.cloudinit);
         res.redirect('/about');});
  //hack for local sensor apis
  // E.g., to invoke the 'playSound' action of a pushButtonSpeaker (type 4) sensor:
  // $.post('/api/action/playSound/4/0013a200408b7932', {values:{'sound':'doorbell'}})
  app.post('/api/action/:action/:sensorType/:sensorId', function(req, res, next){
    var data =  {};
    data.name = req.params.action;
    data.type = req.params.sensorType;
    data.mac = req.params.sensorId;
    data.values = req.body.values;
    console.log(data);
    console.log(req.body);
    console.log(req.params);
    if(data.name && data.mac && data.values){
      handler.emit(data.mac, data);
      res.send(200);
    }else{
      res.send(400);
      console.log('Got an local api request, but was missing a parameter');
    }
  });
}
