var util = require('util');
var _ = require('underscore');
var hue = require("node-hue-api").hue;
var lightState = require('node-hue-api').lightState;
//TODO get these from database somehow

var hostname = "10.253.24.161",
    username = "cc1fe304ae7a5e96c7c2b9fab7827220",
    api;
// **********************************************
function hexToR(h) {return parseInt((cutHex(h)).substring(0,2),16)}
function hexToG(h) {return parseInt((cutHex(h)).substring(2,4),16)}
function hexToB(h) {return parseInt((cutHex(h)).substring(4,6),16)}
function cutHex(h) {return (h.charAt(0)=="#") ? h.substring(1,7):h}

module.exports.boot = function(emitter) {
	var handler = emitter;
  api = new hue.HueApi(hostname, username);
  var timers = {};
  var party = function(id, timeout){
    timeout = timeout || 10000;
    if(timeout > 0){
      console.log('starting party');
      api.setLightState(id, lightState.create().on().effect('colorloop')).done();


    }else{
      console.log('stopping party mode');
      clearInterval(timers[id]);
      api.setLightState(id, lightState.create().on().transition(1)).done();
    }


  }
  var blink = function(id, timeout){
    timeout = timeout || 10000;
    clearInterval(timers[id]);
    console.log("Got a request to blink a light id: " + id + " duration: " + timeout);
    if(timeout > 0){
    api.setLightState(id, lightState.create().alert(true)).done();
  //  api.setLightState(id, lightState.create().on().brightness(100)).done();
      timers[id] = setInterval(function(){
        api.setLightState(id, lightState.create().off()).done();
        setTimeout(function(){
          api.setLightState(id, lightState.create().on()).done();
        }, 2000);
      }, 4000);
    setTimeout(function(){ 
      console.log('stopping blink'); 
      clearInterval(timers[id]);
      api.setLightState(id, lightState.create().on().transition(1)).done();
    }, timeout); 
    }else{
      console.log('stopping blinking');
      clearInterval(timers[id]);
      api.setLightState(id, lightState.create().on().transition(1)).done();
    }
  }
  var dim = function(id) {
    console.log("Got a request to dim a light, id: %s", id);

    api.setLightState(id, lightState.create().on().brightness(20).transition(0.4)).done();

    setTimeout(function() {
      api.setLightState(id, lightState.create().on().brightness(100).transition(0.4)).done();
    }, 450);

    setTimeout(function() {
      api.setLightState(id, lightState.create().on().brightness(20).transition(0.4)).done();
    }, 900);

    setTimeout(function() {
      api.setLightState(id, lightState.create().on().brightness(100).transition(0.4)).done();
    }, 1350);
  };
  var set = function(id, data){
    console.log("Got a request to set the lights id: " + id + " color: " + 
                data.color + " state:" + data.state );
    var r = hexToR(data.color);
    var g = hexToG(data.color);
    var b = hexToB(data.color);
    console.log(r, g, b);
    var onState = lightState.create();
    
    if(data.state == '1'){
      api.setLightState(id, onState.on().rgb(r, g, b)).done();
    }
    else{
      api.setLightState(id, onState.off()).done();
    }
  }
  var register = function(id){
        if(handler.listeners(username + ":" + id).length === 0){
          handler.on(username + ":" + id, function(action){
            console.log("HUE driver got a request");
            console.log(action);
            var id = action.mac.split(':')[1];
            if(id == 'all'){
              switch(action.name){
                case 'blink':
                  api.lights()
                  .then(function(results){
                    results.lights.forEach(function(light){
                      blink(light.id, action.values.duration);
                    });
                  }).done();
                break; 
                case 'set':
                  api.lights()
                  .then(function(results){
                    results.lights.forEach(function(light){
                      set(light.id, action.values);
                    });
                  }).done();
                break;
                case 'party':
                  api.lights()
                  .then(function(results){
                    results.lights.forEach(function(light){
                    party(light.id, action.values.duration);
                    });
                  }).done();
                break;
                case 'dim':
                  api.lights()
                  .then(function(results){
                    results.lights.forEach(function(light){
                      dim(light.id);
                    });
                  }).done();
                break;
              }
            }else{
              switch(action.name){
                case 'set':
                  set(id, action.values);
                break;
                case 'blink':   
                  blink(id, action.values.duration);
                break;  
                case 'party':
                  party(id, action.values.duration);
                break;
                case 'dim':
                  dim(id);
                break;
              }
            }
          });
        }else{
          console.log('sensor registered but already handling requests to that sensor');
        }
  };
  api.lights()
  .then(function(results){
    results.lights.forEach(function(light){
      console.log('Registering light ' + username + ":" + light.id + " " + light.name);
       // handler.emit('sensor_annouce', {id: node.remote64.hex, status: 'on', node: node});	
      //Register id with application event router 
      register(light.id);

      api.lightStatus(light.id).then(function(result) {
        console.log('Light status: mac=%s:%s - %j', username, light.id, result);
        //All bulbs get this type
        result.type = 240;
        handler.emit('sensor_reading', {
          sensorId: username + ":" + light.id,
          payload:  result
        });
      })
      .done();
    });
  })
  .done(function(){
    //register all group 
    console.log("registering the all group"); 
    register('all');
    var result = {type : 241};
    handler.emit('sensor_reading', {
      sensorId: username + ":all",
      payload:  result
    });
  });

}

