var util = require('util');
var _ = require('underscore');
var fs = require('fs');
var lame = require('lame');
var Speaker = require('speaker');
var Driver = require('../gr-gw-driver');
console.log(Driver);

var options = { name: "sound-driver-gw", actions: ['play', 'stop'], type: 242 };

var soundDriver = new Driver(options);


soundDriver.onConnected(function(){
  // Send a singular sensor Reading up to the cloud for just the sound gw itself
  this.sensorReading();
});

soundDriver.onRegistered(function(){
  this.musicPlaying = false;         
  this.speakerInput = null;         
  this.inputStreams = [];         
});

soundDriver.onAction(function(action){
  var self = this;
  var doAction = function(action){
    switch(action.name){
      case 'play':
        playSound(action);
      break;
      case 'stop':
        stopSound();
      break;
    }
  };

  var playSound = function(action){
    if(this.musicPlaying){
      stopSound();
    }
    this.musicPlaying = true;
    //TODO should probably make the sound Names keys to be safe 
    console.log(action);
    stopSound();
    var mp3File = __dirname + '/sound_data/' + action.values.sound;
    //Ok this is what actually plays the sound
    var input = fs.createReadStream(mp3File)
    .pipe(new lame.Decoder())
    .on('format', function(format){
      console.log(format);
      self.speakerInput = new Speaker(format);
      this.pipe(speakerInput);
    });
    var i = self.inputStreams.push(input);
    input.on('close', function(){
      console.log("Stream closed", i);
    });
  };

  var stopSound = function(action){
      self.inputStreams.forEach(function(stream){
        stream.unpipe();
        console.log("stopped stream"); 
      });
  };

  doAction(action);  
});

module.exports = soundDriver;
