

function Driver (options){
  this.name = options.name; this.type = options.type; this.actions = options.actions;
  this.onConnectedCb = function(){};
  this.handler = null;
  this.onRegisteredCb = function(){};
  console.log("Created driver");
}

// Must be called by each driver in order to register itself with the gateway
Driver.prototype.register = function(handler){
  this.handler = handler;
  handler.on(this.name, this.onActionCb.bind(this));  
  handler.on('web_up', this.onConnectedCb.bind(this));  
  this.onRegisteredCb();
};
// Called when the driver is registered with the gateway. Set up instance variables here.
Driver.prototype.onRegistered = function(cb){
  this.onRegisteredCb = cb;
};
// Called when the gateway is connected for each driver
Driver.prototype.onConnected = function(cb){
  this.onConnectedCb = cb;
};

// Reports a sensor reading to the cloud
Driver.prototype.sensorReading = function(sensorId, reading){
  reading = reading || {};
  reading.type = this.type;
  sensorId = (sensorId) ? this.name + "_" + sensorId : this.name;

  this.handler.emit('sensor_reading', {
    sensorId: sensorId,
    payload:  reading
  });


};

Driver.prototype.onAction = function(cb){
  this.onActionCb = cb;

};

module.exports = Driver;
