var sensorDb = require('dirty')('data/sensors.db');
var statusDb = require('dirty')('data/status.db');
var _ = require('underscore');
var sensors = {};
var cloudAuth = false;
var loaded = false;

sensorDb.on('load', function(){
  loaded = true;
  console.log('sensor db loaded');
});

statusDb.on('load', function(){
  statusDb.forEach(function(key, val){
    console.log("found key:" , key, val);
  });

  console.log('status db loaded');
});

statusDb.on('drain', function(){
    console.log("Writes to statusDb complete");
});

module.exports.listSensors = function(cb){
  var list = {};
  sensorDb.forEach(function( k, v){
    list[k]=  v;
  });
  cb(list);
}


module.exports.checkChange = function(data, cb) {
  sensor = sensors[data.sensorId];
  if(_.isEqual(sensor,data)){
    cb(data, false);
  }else{
    sensors[data.sensorId]=  data;
    cb(data, true);
  }
} 

module.exports.registerSensor = function(data, cb){
 sensor = sensorDb.get(data.sensorId);
 if(sensor){
    console.log('sensor already in database');
    cb();
  }else{
    sensorDb.set(data.sensorId, data);
    cb();
  }
}
module.exports.checkCloudInit = function(cb){
  function check() { 
    if(cloudAuth){
      console.log('cloud auth is there');
      return cb(cloudAuth);
    }else{
      //check db
      if(loaded){
        var cloudAuth = statusDb.get('user');
        if(cloudAuth){
          console.log('returned cloud auth', cloudAuth);
          return cb(cloudAuth);
        }else{
          console.log('no cloud Auth in db');
          return cb(null);
        }
      }else{
        var self = this;
        console.log('waiting for statusDb to load');
        setTimeout(function(){
          check(); 
        }, 1000);
      }
    }
  }
  check();
}

module.exports.sensorDb = sensorDb;
module.exports.statusDb = statusDb;
