
var memoryDb = require('../libs/memoryDb.js');
var config = require('../config/conftool').getConf();
var request = require('request');
var async = require('async');
var util = require('util');
memoryDb.checkCloudInit(function(cloudInfo){
  console.log(cloudInfo);
  console.log('sending requests');
  var oauth = { consumer_key : config.cc.consumerKey,
                consumer_secret: config.cc.consumerSecret,
                token: cloudInfo.token.token,
                token_secret: cloudInfo.token.attributes.tokenSecret
              };
  async.waterfall([function(cb){
    request.get({url: 'http://interact.gridreact.com/api/sensor',
             oauth: oauth,
             json: true
            },
    function(err, res, body){
      console.log('testing /api/sensor');
      console.log(res.statusCode);
      console.log(util.inspect(body,{depth: null, colors: true}));
      cb(null, body.sensors[3].mac);
    });
  },
  function(mac, cb){
    request.get({url: 'http://interact.gridreact.com/api/sensor/' + mac,
             oauth: oauth,
             json: true
            },
    function(err, res, body){
      console.log('testing /api/sensor/' + mac);
      console.log(res.statusCode);
      console.log(util.inspect(body,{depth: null, colors: true}));
      cb(null, mac);
    });
  },
  function(mac, cb){
    request.get({url: 'http://interact.gridreact.com/api/action/' + mac,
             oauth: oauth,
             json: true
            },
    function(err, res, body){
      console.log('testing /api/action/' + mac);
      console.log(res.statusCode);
      console.log(util.inspect(body,{depth: null, colors: true}));
      cb(null, mac);
    });
  },
  function(mac, cb){
    var data = { line1: 'hello', line2: 'world', timeout: '30000' } ;
    request.post({url: 'http://interact.gridreact.com/api/action/' + mac + '/setString',
             body : data, 
             oauth: oauth,
             json: true
            },
    function(err, res, body){
      console.log('testing /api/action/' + mac);
      console.log(res.statusCode);
      console.log(util.inspect(body,{depth: null, colors: true}));
      cb(null, mac);
    });
  }],
  function(err, results){
    if(err){
      console.log(err.stack);
    }else{
      console.log('complete');
    }
  });
});

